/*
 * A2V : A2VDlg.cpp
 *
 * Copyright 1998, Sony Computer Entertainment Inc.
 */

#include "stdafx.h"
#include "A2V.h"
#include "A2VDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog for version information

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CA2VDlg dialog

CA2VDlg::CA2VDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CA2VDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CA2VDlg)
	m_editSrc = _T("");
	m_editDst = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CA2VDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CA2VDlg)
	DDX_Control(pDX, IDC_BUTTON_CNV, m_button_cnv);
	DDX_Text(pDX, IDC_EDIT_SRC, m_editSrc);
	DDV_MaxChars(pDX, m_editSrc, 256);
	DDX_Text(pDX, IDC_EDIT_DST, m_editDst);
	DDV_MaxChars(pDX, m_editDst, 256);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CA2VDlg, CDialog)
	//{{AFX_MSG_MAP(CA2VDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_SRC, OnButtonSrc)
	ON_BN_CLICKED(IDC_BUTTON_DST, OnButtonDst)
	ON_BN_CLICKED(IDC_BUTTON_CNV, OnButtonCnv)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CA2VDlg message handler

BOOL CA2VDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// add "version info" to system menu
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	SetIcon(m_hIcon, TRUE);	
	SetIcon(m_hIcon, FALSE);	
	
	return TRUE;
}

void CA2VDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CA2VDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// center of client
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CA2VDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


/////////////////////////////////////////////////////////////////////////////
// my message handler

void CA2VDlg::OnButtonSrc() // "input file browse button" pressed
{
	CFileDialog loadDialog(TRUE, "aif", m_editSrc, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "AIFF Files (*.aif ; *.aiff)|*.aif; *.aiff|All Files (*.*)|*.*||" );
	loadDialog.DoModal();
	srcPath = loadDialog.GetPathName();

	dstPath = srcPath;

	if( dstPath.GetLength() > 4 ) {
		if( dstPath.GetAt(dstPath.GetLength()-4) == '.' ) {
			dstPath = dstPath.GetBufferSetLength(dstPath.GetLength()-4);
		} 
		else if( dstPath.GetAt(dstPath.GetLength()-5) == '.' ) {
			dstPath = dstPath.GetBufferSetLength(dstPath.GetLength()-5);
		} 
		dstPath += ".vag";
	} 

	noExName = loadDialog.GetFileTitle();
	m_editSrc = srcPath;  // set input path to edit box
	m_editDst = dstPath;  // set output path to edit box
	UpdateData(FALSE);
}


void CA2VDlg::OnButtonDst()  // "output file browse button" pressed
{
	CFileDialog saveDialog(FALSE, "vag", m_editDst, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "VAG Files (*.vag)|*.vag|All Files (*.*)|*.*||" );
	saveDialog.DoModal();
	dstPath = saveDialog.GetPathName();	
	m_editDst = dstPath;
	UpdateData(FALSE);
}

void CA2VDlg::OnButtonCnv()  // "convert button" pressed

{
	UpdateData(TRUE);
	dstPath = m_editDst;
	srcPath = m_editSrc;

	if( arFp.Open( (LPCTSTR)srcPath, CFile::modeRead ) == NULL ) {
		errStr = "Can't open input file : " + srcPath;
		goto ABORT;
	}

	if ( vagFile.Open( (LPCTSTR)dstPath, CFile::modeCreate | CFile::modeWrite, &vagFileError ) == NULL ){
		errStr = "Can't open output file : " + dstPath;
		goto ABORT;
	}

	m_button_cnv.EnableWindow(FALSE); // unabled convert button 
	UpdateData(TRUE);

	Convert( 0 ); // main convert routine
	arFp.Close();
	vagFile.Close();

	m_button_cnv.EnableWindow(TRUE); // enabled convert button 
	UpdateData(TRUE);
	return;

ABORT:
	AfxMessageBox(errStr);
	return;
}
