#ifndef _LIBSPU_H_
#define _LIBSPU_H_

/*****************************************************************
 * -*- c -*-
 * $RCSfile: libspu.h,v $
 *
 * Copyright (c) 1993, 1994, 1995, 1996 Sony Computer Entertainment Inc.
 * All Rights Reserved.
 *
 * This file is part of ``PlayStation(R)'' Programmer Tool /
 * Runtime Library.
 *
 * R & D Division, Sony Computer Entertainment Inc.
 *
 * $Id: libspu.h,v 1.78 1996/12/17 11:18:26 kaol Exp $
 *
 *****************************************************************/
/*
 * $PSLibId: Run-time Library Release 3.7$
 */

/* ----------------------------------------------------------------
 *	CONSTANT 
 * ---------------------------------------------------------------- */

#define SPU_SUCCESS	0
#define SPU_INVALID_ARGS (-3)
#define SPU_DIAG	(-2)
#define SPU_CHECK	(-1)
#define SPU_OFF		0
#define SPU_ON		1
#define SPU_CLEAR	2
#define SPU_RESET	3
#define SPU_DONT_CARE	4
#define SPU_ALL		0
#define SPU_CDONLY	5
#define SPU_VOICEONLY	6
#define SPU_CONT	7
#define SPU_NULL	0
/* Macros below will be obsoleted. */
#define SpuDiag		SPU_DIAG
#define SpuCheck	SPU_CHECK
#define SpuOff		SPU_OFF
#define SpuOn		SPU_ON
#define SpuClear	SPU_CLEAR
#define SpuReset	SPU_RESET
#define SpuDontCare	SPU_DONT_CARE
#define SpuALL		SPU_ALL
#define SpuCDOnly	SPU_CDONLY
#define SpuVoiceOnly	SPU_VOICEONLY
#define SpuCont		SPU_CONT
#define SpuNull		SPU_NULL

#define SPU_OFF_ENV_ON	2
#define SPU_ON_ENV_OFF	3
/* Macros below will be obsoleted. */
#define SpuOffEnvOn	SPU_OFF_ENV_ON
#define SpuOnEnvOff	SPU_ON_ENV_OFF

#define SPU_ERROR	(-1)
/* Macros below will be obsoleted. */
#define SpuError	SPU_ERROR

#define SPU_TRANSFER_BY_DMA 0L
#define SPU_TRANSFER_BY_IO 1L
/* Macros below will be obsoleted. */
#define SpuTransferByDMA SPU_TRANSFER_BY_DMA
#define SpuTransferByIO  SPU_TRANSFER_BY_IO
#define SpuTransByDMA SpuTransferByDMA
#define SpuTransByIO SpuTransferByIO

#define SPU_TRANSFER_WAIT 1
#define SPU_TRANSFER_PEEK 0
#define SPU_TRANSFER_GLANCE SPU_TRANSFER_PEEK

/*
 * Voice designate
 */

#ifndef __SPU_VOICE
#define __SPU_VOICE

#define SPU_00CH (0x1L<< 0)
#define SPU_01CH (0x1L<< 1)
#define SPU_02CH (0x1L<< 2)
#define SPU_03CH (0x1L<< 3)
#define SPU_04CH (0x1L<< 4)
#define SPU_05CH (0x1L<< 5)
#define SPU_06CH (0x1L<< 6)
#define SPU_07CH (0x1L<< 7)
#define SPU_08CH (0x1L<< 8)
#define SPU_09CH (0x1L<< 9)
#define SPU_10CH (0x1L<<10)
#define SPU_11CH (0x1L<<11)
#define SPU_12CH (0x1L<<12)
#define SPU_13CH (0x1L<<13)
#define SPU_14CH (0x1L<<14)
#define SPU_15CH (0x1L<<15)
#define SPU_16CH (0x1L<<16)
#define SPU_17CH (0x1L<<17)
#define SPU_18CH (0x1L<<18)
#define SPU_19CH (0x1L<<19)

#define SPU_20CH (0x1L<<20)
#define SPU_21CH (0x1L<<21)
#define SPU_22CH (0x1L<<22)
#define SPU_23CH (0x1L<<23)

#define SPU_0CH SPU_00CH
#define SPU_1CH SPU_01CH
#define SPU_2CH SPU_02CH
#define SPU_3CH SPU_03CH
#define SPU_4CH SPU_04CH
#define SPU_5CH SPU_05CH
#define SPU_6CH SPU_06CH
#define SPU_7CH SPU_07CH
#define SPU_8CH SPU_08CH
#define SPU_9CH SPU_09CH

#define SPU_ALLCH (SPU_00CH | SPU_01CH | SPU_02CH | SPU_03CH | SPU_04CH | \
		   SPU_05CH | SPU_06CH | SPU_07CH | SPU_08CH | SPU_09CH | \
		   SPU_10CH | SPU_11CH | SPU_12CH | SPU_13CH | SPU_14CH | \
		   SPU_15CH | SPU_16CH | SPU_17CH | SPU_18CH | SPU_19CH | \
		   SPU_20CH | SPU_21CH | SPU_22CH | SPU_23CH)

#define SPU_KEYCH(x) (0x1L<<(x))
#define SPU_VOICECH(x) SPU_KEYCH(x)

#endif /* __SPU_VOICE */

/* for Voice setting */

#define	SPU_VOICE_VOLL		    (0x01 <<  0) /* ()                 */
#define	SPU_VOICE_VOLR		    (0x01 <<  1) /* (E)                 */
#define	SPU_VOICE_VOLMODEL	    (0x01 <<  2) /* ʃ[h()           */
#define	SPU_VOICE_VOLMODER	    (0x01 <<  3) /* ʃ[h(E)           */
#define	SPU_VOICE_PITCH		    (0x01 <<  4) /*  (sb`w)        */
#define	SPU_VOICE_NOTE		    (0x01 <<  5) /*  (m[gw)        */
#define	SPU_VOICE_SAMPLE_NOTE	(0x01 <<  6) /* g`f[^Tvm[g */
#define	SPU_VOICE_WDSA		    (0x01 <<  7) /* g`f[^擪AhX   */
#define	SPU_VOICE_ADSR_AMODE	(0x01 <<  8) /* ADSR Attack rate [h  */
#define	SPU_VOICE_ADSR_SMODE	(0x01 <<  9) /* ADSR Sustain rate [h */
#define	SPU_VOICE_ADSR_RMODE	(0x01 << 10) /* ADSR Release rate [h */
#define	SPU_VOICE_ADSR_AR	    (0x01 << 11) /* ADSR Attack rate         */
#define	SPU_VOICE_ADSR_DR	    (0x01 << 12) /* ADSR Decay rate          */
#define	SPU_VOICE_ADSR_SR	    (0x01 << 13) /* ADSR Sustain rate        */
#define	SPU_VOICE_ADSR_RR	    (0x01 << 14) /* ADSR Release rate        */
#define	SPU_VOICE_ADSR_SL	    (0x01 << 15) /* ADSR Sustain level       */
#define	SPU_VOICE_LSAX		    (0x01 << 16) /* [vJnAhX       */
#define	SPU_VOICE_ADSR_ADSR1	(0x01 << 17) /* ADSR adsr1 for `VagAtr'  */
#define	SPU_VOICE_ADSR_ADSR2	(0x01 << 18) /* ADSR adsr2 for `VagAtr'  */

#define	SPU_VOICE_DIRECT	    0
#define	SPU_VOICE_LINEARIncN	1
#define	SPU_VOICE_LINEARIncR	2
#define	SPU_VOICE_LINEARDecN	3
#define	SPU_VOICE_LINEARDecR	4
#define	SPU_VOICE_EXPIncN	    5
#define	SPU_VOICE_EXPIncR    	6
#define	SPU_VOICE_EXPDec	    7
#define	SPU_VOICE_EXPDecN	    SPU_VOICE_EXPDec
#define	SPU_VOICE_EXPDecR	    SPU_VOICE_EXPDec

#define	SPU_DECODED_FIRSTHALF	0
#define	SPU_DECODED_SECONDHALF	1
#define	SPU_DECODE_FIRSTHALF	SPU_DECODED_FIRSTHALF
#define	SPU_DECODE_SECONDHALF	SPU_DECODED_SECONDHALF


#define	SPU_COMMON_MVOLL		(0x01 <<  0) /* }X^()                     */
#define	SPU_COMMON_MVOLR		(0x01 <<  1) /* }X^(E)                     */
#define	SPU_COMMON_MVOLMODEL	(0x01 <<  2) /* }X^ʃ[h()               */
#define	SPU_COMMON_MVOLMODER	(0x01 <<  3) /* }X^ʃ[h(E)               */
#define	SPU_COMMON_RVOLL		(0x01 <<  4) /* o[u()                   */
#define	SPU_COMMON_RVOLR		(0x01 <<  5) /* o[u(E)                   */
#define	SPU_COMMON_CDVOLL		(0x01 <<  6) /* CD   ()                  */
#define	SPU_COMMON_CDVOLR		(0x01 <<  7) /* CD   (E)                  */
#define	SPU_COMMON_CDREV		(0x01 <<  8) /* CD  o[uI/It          */
#define	SPU_COMMON_CDMIX		(0x01 <<  9) /* CD  I/It                  */
#define	SPU_COMMON_EXTVOLL		(0x01 << 10) /* OfW^  ()         */
#define	SPU_COMMON_EXTVOLR		(0x01 << 11) /* OfW^  (E)         */
#define	SPU_COMMON_EXTREV		(0x01 << 12) /* OfW^ o[uI/It */
#define	SPU_COMMON_EXTMIX		(0x01 << 13) /* OfW^ I/It         */

/* for Reverb setting */

#define	SPU_REV_MODE		(0x01 <<  0) /* [hݒ                     */
#define	SPU_REV_DEPTHL		(0x01 <<  1) /* o[u̐[()             */
#define	SPU_REV_DEPTHR		(0x01 <<  2) /* o[u̐[(E)             */
#define	SPU_REV_DELAYTIME	(0x01 <<  3) /* Delay Time (ECHO, DELAY ̂)  */
#define	SPU_REV_FEEDBACK	(0x01 <<  4) /* Feedback   (ECHO ̂)         */

#define SPU_REV_MODE_CHECK	   (-1)
#define SPU_REV_MODE_OFF	    0
#define SPU_REV_MODE_ROOM	    1
#define SPU_REV_MODE_STUDIO_A	2
#define SPU_REV_MODE_STUDIO_B	3
#define SPU_REV_MODE_STUDIO_C	4
#define SPU_REV_MODE_HALL	    5
#define SPU_REV_MODE_SPACE	    6
#define SPU_REV_MODE_ECHO	    7
#define SPU_REV_MODE_DELAY	    8
#define SPU_REV_MODE_PIPE	    9
#define SPU_REV_MODE_MAX	   10

#define SPU_REV_MODE_CLEAR_WA	0x100

/* ----------------------------------------------------------------
 *	Event flushing
 * ---------------------------------------------------------------- */

#define SPU_EVENT_KEY      (0x01 << 0)
#define SPU_EVENT_PITCHLFO (0x01 << 1)
#define SPU_EVENT_NOISE    (0x01 << 2)
#define SPU_EVENT_REVERB   (0x01 << 3)

#define SPU_EVENT_ALL 0

/* ----------------------------------------------------------------
 *	Structure
 * ---------------------------------------------------------------- */

typedef struct {
    short left;	       /* Lch */
    short right;       /* Rch */
} SpuVolume;

typedef struct {
    unsigned long	voice;		 /* ݒ{CX:
					                SpuSetVoiceAttr: e{CX bit 
					                SpuGetVoiceAttr: {CX bit l
					             */
    unsigned long	mask;		 /* ݒ葮rbg (Get ł͖)	*/
    SpuVolume		volume;		 /* 					        */
    SpuVolume		volmode;	 /* ʃ[h				        */
    SpuVolume		volumex;	 /* ݂̉ (Set ł͖)		*/
    unsigned short	pitch;		 /*  (sb`w)			*/
    unsigned short	note;		 /*  (m[gw)			*/
    unsigned short	sample_note; /*  (m[gw)			*/
    short		    envx;	     /* ݂̃Gx[vl (Set ł͖)  */
    unsigned long	addr;		 /* g`f[^擪AhX		*/
    unsigned long	loop_addr;	 /* [vJnAhX			*/
    long		    a_mode;	     /* Attack rate mode			*/
    long		    s_mode;	     /* Sustain rate mode			*/
    long		    r_mode;	     /* Release rate mode			*/
    unsigned short	ar;		     /* Attack rate				    */
    unsigned short	dr;		     /* Decay rate				    */
    unsigned short	sr;		     /* Sustain rate				*/
    unsigned short	rr;		     /* Release rate				*/
    unsigned short	sl;		     /* Sustain level			    */
    unsigned short	adsr1;		 /* adsr1 for `VagAtr' */
    unsigned short	adsr2;		 /* adsr2 for `VagAtr' */
} SpuVoiceAttr;

typedef struct {
    unsigned long	mask;	  /* ݒ}XN*/
    
    long		    mode;	  /* o[u[h */
    SpuVolume		depth;	  /* o[u̐[ */
    long            delay;	  /* Delay Time (ECHO, DELAY ̂)  */
    long            feedback; /* Feedback   (ECHO ̂)         */
} SpuReverbAttr;

#define SPU_DECODEDDATA_SIZE 0x200
#define SPU_DECODEDATA_SIZE SPU_DECODEDDATA_SIZE
typedef struct {
    short cd_left  [SPU_DECODEDDATA_SIZE];
    short cd_right [SPU_DECODEDDATA_SIZE];
    short voice1   [SPU_DECODEDDATA_SIZE];
    short voice3   [SPU_DECODEDDATA_SIZE];
} SpuDecodedData;
typedef SpuDecodedData SpuDecodeData;

typedef struct {
    SpuVolume	volume;		  /* 		  */
    long	reverb;		  /* o[uI/It	  */
    long	mix;		  /* ~LVOI/It  */
} SpuExtAttr;

typedef struct {
    unsigned long	mask;	  /* ݒ}XN		  */
    
    SpuVolume		mvol;	  /* }X^		  */
    SpuVolume		mvolmode; /* }X^ʃ[h	  */
    SpuVolume		mvolx;	  /* ݂̃}X^	  */
    SpuExtAttr		cd;	  /* CD ͑	  */
    SpuExtAttr		ext;	  /* OfW^͑ */
} SpuCommonAttr;

#ifndef __SPU_IRQCALLBACK_PROC
#define __SPU_IRQCALLBACK_PROC
typedef void (*SpuIRQCallbackProc)(void);
#endif /* __SPU_IRQCALLBACK_PROC */
#ifndef __SPU_TRANSFERCALLBACK_PROC
#define __SPU_TRANSFERCALLBACK_PROC
typedef void (*SpuTransferCallbackProc)(void);
#endif /* __SPU_TRANSFERCALLBACK_PROC */

/* ----------------------------------------------------------------
 *	for SPU Malloc (used in SpuInitMalloc())
 * ---------------------------------------------------------------- */

#define SPU_MALLOC_RECSIZ 8

/* ----------------------------------------------------------------
 *	User specifiable global environment
 * ---------------------------------------------------------------- */

typedef struct {
    unsigned long mask;
    unsigned long queueing;
} SpuEnv;

#define SPU_ENV_EVENT_QUEUEING			(0x01 << 0)


#define DLLEXP_VOID     extern "C" __declspec(dllexport) void  __stdcall
#define DLLEXP_LONG     extern "C" __declspec(dllexport) long  __stdcall
#define DLLEXP_ULONG    extern "C" __declspec(dllexport) unsigned long  __stdcall
#define DLLEXP_SHORT    extern "C" __declspec(dllexport) short  __stdcall

DLLEXP_VOID   SpuInit (void);    // Visual C++ Visual BasicΉ
DLLEXP_VOID   SpuStart (void);  
DLLEXP_VOID   SpuQuit (void);   
DLLEXP_LONG   SpuSetMute (long on_off);
DLLEXP_LONG   SpuGetMute (void);
DLLEXP_VOID   SpuSetEnv (SpuEnv *env);
DLLEXP_LONG   SpuSetNoiseClock (long n_clock);
DLLEXP_LONG   SpuGetNoiseClock (void);
DLLEXP_ULONG  SpuSetNoiseVoice (long on_off, unsigned long voice_bit);
DLLEXP_ULONG  SpuGetNoiseVoice (void);


DLLEXP_LONG   SpuSetReverb (long on_off);
DLLEXP_LONG   SpuGetReverb (void);
DLLEXP_LONG   SpuSetReverbModeParam (SpuReverbAttr *attr);
DLLEXP_VOID   SpuGetReverbModeParam (SpuReverbAttr *attr);
DLLEXP_LONG   SpuSetReverbDepth (SpuReverbAttr *attr);
DLLEXP_LONG   SpuReserveReverbWorkArea (long on_off);
DLLEXP_LONG   SpuIsReverbWorkAreaReserved (long on_off);
DLLEXP_ULONG  SpuSetReverbVoice (long on_off, unsigned long voice_bit);
DLLEXP_ULONG  SpuGetReverbVoice (void);
DLLEXP_LONG   SpuClearReverbWorkArea (long mode);


DLLEXP_ULONG  SpuWrite (unsigned char *addr, unsigned long size);
DLLEXP_ULONG  SpuWrite0 (unsigned long size);
DLLEXP_ULONG  SpuRead (unsigned char *addr, unsigned long size);
DLLEXP_LONG   SpuSetTransferMode (long mode);
DLLEXP_LONG   SpuGetTransferMode (void);
DLLEXP_ULONG  SpuSetTransferStartAddr (unsigned long addr);
DLLEXP_ULONG  SpuGetTransferStartAddr (void);
DLLEXP_ULONG  SpuWritePartly (unsigned char *addr, unsigned long size);
DLLEXP_LONG   SpuIsTransferCompleted (long flag);



DLLEXP_VOID  SpuSetVoiceAttr (SpuVoiceAttr *arg);
DLLEXP_VOID  SpuGetVoiceAttr (SpuVoiceAttr *arg);
DLLEXP_VOID  SpuSetKey (long on_off, unsigned long voice_bit);
DLLEXP_VOID  SpuSetKeyOnWithAttr (SpuVoiceAttr *attr);
DLLEXP_LONG  SpuGetKeyStatus (unsigned long voice_bit);
DLLEXP_VOID  SpuGetAllKeysStatus (char *status);
DLLEXP_ULONG SpuFlush (unsigned long ev);
DLLEXP_ULONG SpuSetPitchLFOVoice (long on_off, unsigned long voice_bit);
DLLEXP_ULONG SpuGetPitchLFOVoice (void);
DLLEXP_VOID  SpuSetCommonAttr (SpuCommonAttr *attr);
DLLEXP_VOID  SpuGetCommonAttr (SpuCommonAttr *attr);
DLLEXP_LONG  SpuInitMalloc (long num, char *top);
DLLEXP_LONG  SpuMalloc (long size);
DLLEXP_LONG  SpuMallocWithStartAddr (unsigned long addr, long size);
DLLEXP_VOID  SpuFree (unsigned long addr);
DLLEXP_LONG  SpuRGetAllKeysStatus (long min_, long max_, char *status);
DLLEXP_LONG  SpuRSetVoiceAttr (long min_, long max_, SpuVoiceAttr *arg);
DLLEXP_SHORT SpuGetCurrentEnvelope (unsigned long arg);

DLLEXP_VOID  SpuNSetVoiceAttr (int vNum, SpuVoiceAttr *arg);
DLLEXP_VOID  SpuNGetVoiceAttr (int vNum, SpuVoiceAttr *arg);

DLLEXP_VOID  SpuSetVoiceVolume (int vNum, short volL, short volR);
DLLEXP_VOID  SpuSetVoiceVolumeAttr (int vNum, short volL, short volR,short volModeL, short volModeR);
DLLEXP_VOID  SpuSetVoicePitch (int vNum, unsigned short pitch);
DLLEXP_VOID  SpuSetVoiceNote (int vNum, unsigned short note);
DLLEXP_VOID  SpuSetVoiceSampleNote (int vNum, unsigned short sampleNote);
DLLEXP_VOID  SpuSetVoiceStartAddr (int vNum, unsigned long startAddr);
DLLEXP_VOID  SpuSetVoiceLoopStartAddr (int vNum, unsigned long lsa);
DLLEXP_VOID  SpuSetVoiceAR (int vNum, unsigned short AR);
DLLEXP_VOID  SpuSetVoiceDR (int vNum, unsigned short DR);
DLLEXP_VOID  SpuSetVoiceSR (int vNum, unsigned short SR);
DLLEXP_VOID  SpuSetVoiceRR (int vNum, unsigned short RR);
DLLEXP_VOID  SpuSetVoiceSL (int vNum, unsigned short SL);
DLLEXP_VOID  SpuSetVoiceARAttr (int vNum, unsigned short AR, long ARmode);
DLLEXP_VOID  SpuSetVoiceSRAttr (int vNum, unsigned short SR, long SRmode);
DLLEXP_VOID  SpuSetVoiceRRAttr (int vNum, unsigned short RR, long RRmode);
DLLEXP_VOID  SpuSetVoiceADSR ( int vNum, unsigned short AR, unsigned short DR,
		                       unsigned short SR, unsigned short RR,
			                   unsigned short SL);
DLLEXP_VOID  SpuSetVoiceADSRAttr ( int vNum,
			                       unsigned short AR, unsigned short DR,
			                       unsigned short SR, unsigned short RR,
			                       unsigned short SL,
			                       long ARmode, long SRmode, long RRmode);

DLLEXP_VOID  SpuGetVoiceVolume (int vNum, short *volL, short *volR);
DLLEXP_VOID  SpuGetVoiceVolumeAttr ( int vNum, short *volL, short *volR,
		    		                    short *volModeL, short *volModeR);
DLLEXP_VOID  SpuGetVoiceVolumeX (int vNum, short *volXL, short *volXR);
DLLEXP_VOID  SpuGetVoicePitch (int vNum, unsigned short *pitch);
DLLEXP_VOID  SpuGetVoiceNote (int vNum, unsigned short *note);
DLLEXP_VOID  SpuGetVoiceSampleNote (int vNum, unsigned short *sampleNote);
DLLEXP_VOID  SpuGetVoiceEnvelope (int vNum, short *envx);
DLLEXP_VOID  SpuGetVoiceStartAddr (int vNum, unsigned long *startAddr);
DLLEXP_VOID  SpuGetVoiceLoopStartAddr (int vNum, unsigned long *loopStartAddr);
DLLEXP_VOID  SpuGetVoiceAR (int vNum, unsigned short *AR);
DLLEXP_VOID  SpuGetVoiceDR (int vNum, unsigned short *DR);
DLLEXP_VOID  SpuGetVoiceSR (int vNum, unsigned short *SR);
DLLEXP_VOID  SpuGetVoiceRR (int vNum, unsigned short *RR);
DLLEXP_VOID  SpuGetVoiceSL (int vNum, unsigned short *SL);
DLLEXP_VOID  SpuGetVoiceARAttr (int vNum, unsigned short *AR, long *ARmode);
DLLEXP_VOID  SpuGetVoiceSRAttr (int vNum, unsigned short *SR, long *SRmode);
DLLEXP_VOID  SpuGetVoiceRRAttr (int vNum, unsigned short *RR, long *RRmode);
DLLEXP_VOID  SpuGetVoiceADSR (int vNum,
			                  unsigned short *AR, unsigned short *DR,
			                  unsigned short *SR, unsigned short *RR,
			                  unsigned short *SL);
DLLEXP_VOID  SpuGetVoiceADSRAttr (int vNum,
			                      unsigned short *AR, unsigned short *DR,
			                      unsigned short *SR, unsigned short *RR,
			                      unsigned short *SL,
			                      long *ARmode, long *SRmode, long *RRmode);

DLLEXP_VOID  SpuGetVoiceEnvelopeAttr (int vNum, long *keyStat, short *envx );
DLLEXP_VOID  SpuSetCommonMasterVolume (short mvol_left, short mvol_right);
DLLEXP_VOID  SpuSetCommonMasterVolumeAttr ( short mvol_left, short mvol_right,
			      						    short mvolmode_left,
											short mvolmode_right);
DLLEXP_VOID  SpuSetCommonCDMix (long cd_mix);
DLLEXP_VOID  SpuSetCommonCDVolume (short cd_left, short cd_right);
DLLEXP_VOID  SpuSetCommonCDReverb (long cd_reverb);

DLLEXP_VOID  SpuGetCommonMasterVolume ( short *mvol_left, short *mvol_right);
DLLEXP_VOID  SpuGetCommonMasterVolumeX ( short *mvolx_left, short *mvolx_right);
DLLEXP_VOID  SpuGetCommonMasterVolumeAttr ( short *mvol_left, short *mvol_right,
                       					    short *mvolmode_left,
					                        short *mvolmode_right);
DLLEXP_VOID  SpuGetCommonCDMix (long *cd_mix);
DLLEXP_VOID  SpuGetCommonCDVolume (short *cd_left, short *cd_right);
DLLEXP_VOID  SpuGetCommonCDReverb (long *cd_reverb);


DLLEXP_LONG  SpuSetReverbModeType (long mode);
DLLEXP_VOID  SpuSetReverbModeDepth (short depth_left, short depth_right);
DLLEXP_VOID  SpuSetReverbModeDelayTime (long delay);
DLLEXP_VOID  SpuSetReverbModeFeedback (long feedback);
DLLEXP_VOID  SpuGetReverbModeType (long *mode);
DLLEXP_VOID  SpuGetReverbModeDepth (short *depth_left, short *depth_right);
DLLEXP_VOID  SpuGetReverbModeDelayTime (long *delay);
DLLEXP_VOID  SpuGetReverbModeFeedback (long *feedback);

#endif